(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/slider'), require('@angular/material/divider'), require('@angular/forms'), require('@angular/common'), require('@angular/material/list')) :
    typeof define === 'function' && define.amd ? define('ngx-mat-range-slider', ['exports', '@angular/core', '@angular/material/slider', '@angular/material/divider', '@angular/forms', '@angular/common', '@angular/material/list'], factory) :
    (global = global || self, factory(global['ngx-mat-range-slider'] = {}, global.ng.core, global.ng.material.slider, global.ng.material.divider, global.ng.forms, global.ng.common, global.ng.material.list));
}(this, (function (exports, core, slider, divider, forms, common, list) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var NgxMatRangeSliderComponent = /** @class */ (function () {
        function NgxMatRangeSliderComponent() {
            this.isMinValueInit = true;
            this.isMaxValueInit = true;
            this.thumbLabel = true;
            this.minColor = 'accent';
            this.maxColor = 'primary';
            this.showRuler = false;
            this.formatLabel = function (v) { return v; };
            this.output = new core.EventEmitter();
            this.maxConf = 75;
            this.minConf = 18;
        }
        Object.defineProperty(NgxMatRangeSliderComponent.prototype, "max", {
            get: function () {
                return this.maxConf;
            },
            set: function (m) {
                this.maxConf = parseInt(m.toString(), 10);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgxMatRangeSliderComponent.prototype, "min", {
            get: function () {
                return this.minConf;
            },
            set: function (m) {
                this.minConf = parseInt(m.toString(), 10);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgxMatRangeSliderComponent.prototype, "value", {
            set: function (v) {
                this.minValue = v.min;
                this.maxValue = v.max;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgxMatRangeSliderComponent.prototype, "rulerArray", {
            get: function () {
                var _this = this;
                return __spread(Array(this.max - this.min).keys()).map(function (i) { return i + _this.min; });
            },
            enumerable: false,
            configurable: true
        });
        NgxMatRangeSliderComponent.prototype.ngOnInit = function () {
            if (!this.minValue) {
                this.minValue = this.min;
            }
            if (!this.maxValue) {
                this.maxValue = this.max;
            }
            this.isMinValueInit = (this.minValue === this.min);
            this.isMaxValueInit = (this.maxValue === this.max);
            this.output.emit({ min: this.minValue, max: this.maxValue });
        };
        NgxMatRangeSliderComponent.prototype.valueChange = function () {
            this.output.emit({ min: this.minValue, max: this.maxValue });
        };
        NgxMatRangeSliderComponent.prototype.minValueInput = function (a) {
            this.isMinValueInit = (a.value === this.min);
            if (a.value >= this.maxValue) {
                a.source.value = this.maxValue;
            }
        };
        NgxMatRangeSliderComponent.prototype.maxValueInput = function (a) {
            this.isMaxValueInit = (a.value === this.max);
            if (a.value <= this.minValue) {
                a.source.value = this.minValue;
            }
        };
        return NgxMatRangeSliderComponent;
    }());
    NgxMatRangeSliderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'lib-ngx-mat-range-slider',
                    template: "<div class=\"full-width ranger-slider\">\n  <mat-slider\n    (change)=\"valueChange()\"\n    (input)=\"minValueInput($event)\"\n    [(ngModel)]=\"minValue\"\n    [color]=\"minColor\"\n    [displayWith]=\"formatLabel\"\n    [max]=\"max\"\n    [min]=\"min\"\n    [thumbLabel]=\"thumbLabel\"\n    class=\"full-width cdk-focused slider-over slider-min-value\"\n    step=\"1\">\n  </mat-slider>\n  <mat-slider\n    (change)=\"valueChange()\"\n    (input)=\"maxValueInput($event)\"\n    [(ngModel)]=\"maxValue\"\n    [color]=\"maxColor\"\n    [displayWith]=\"formatLabel\"\n    [max]=\"max\"\n    [min]=\"min\"\n    [thumbLabel]=\"thumbLabel\"\n    class=\"full-width cdk-focused slider-over slider-max-value\"\n    step=\"1\">\n  </mat-slider>\n  <div class=\"full-width slider-over slider-line-cover-wrapper\">\n    <mat-divider [class]=\"isMinValueInit? 'slider-line-cover-init' : 'slider-line-cover'\"></mat-divider>\n    <mat-divider [class]=\"isMaxValueInit? 'slider-line-cover-init' : 'slider-line-cover'\"></mat-divider>\n  </div>\n\n  <div *ngIf=\"showRuler\" class=\"outer\">\n    <div class=\"middle\">\n      <div *ngFor=\"let key of rulerArray\" class=\"inner\">|</div>\n    </div>\n    <div class=\"middle\">\n      <div *ngFor=\"let key of rulerArray\" class=\"inner\"><span>{{key}}</span></div>\n    </div>\n  </div>\n</div>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    styles: [".slider-over{left:0;position:absolute!important;top:16px}mat-slider{padding-left:0;padding-right:0}ngx-mat-range-slider{height:60px}ngx-mat-range-slider .mat-slider-thumb-label{border-radius:50% 50% 0!important;transform:rotate(45deg)!important}ngx-mat-range-slider .mat-slider-thumb-label-text{opacity:1!important;transform:rotate(-45deg)!important}ngx-mat-range-slider .mat-slider-thumb{transform:scale(0)}ngx-mat-range-slider .mat-slider-track-wrapper{background:#66bb6a}ngx-mat-range-slider .slider-min-value .mat-slider-track-fill,ngx-mat-range-slider .slider-min-value .mat-slider-track-fill:focus{background-color:#bdbdbd!important;outline:#bdbdbd;z-index:99}ngx-mat-range-slider .slider-min-value .mat-slider-track-background,ngx-mat-range-slider .slider-min-value .mat-slider-track-background:focus{display:none}ngx-mat-range-slider .slider-max-value .mat-slider-track-background,ngx-mat-range-slider .slider-max-value .mat-slider-track-background:focus{background-color:#bdbdbd!important;outline:#bdbdbd;z-index:99}ngx-mat-range-slider .slider-max-value .mat-slider-track-fill,ngx-mat-range-slider .slider-max-value .mat-slider-track-fill:focus{display:none}ngx-mat-range-slider .slider-line-cover-wrapper{display:table;top:39px;z-index:-1}ngx-mat-range-slider .slider-line-cover-wrapper .slider-line-cover{background-color:#bdbdbd!important;border-bottom:1px solid #bdbdbd!important;display:table-cell;width:50%}ngx-mat-range-slider .slider-line-cover-wrapper .slider-line-cover-init{background-color:#66bb6a!important;border-bottom:1px solid #66bb6a!important;display:table-cell;width:50%}ngx-mat-range-slider div.outer{border-top:2px solid red;display:table;width:100%}ngx-mat-range-slider div.middle:first-of-type{display:table-row;font-size:5px}ngx-mat-range-slider div.middle:nth-of-type(2){display:table-row;font-size:10px}ngx-mat-range-slider div.middle:nth-of-type(2) span{-ms-writing-mode:tb-rl;-webkit-text-orientation:upright;font-size:10px;text-orientation:upright;writing-mode:vertical-rl}ngx-mat-range-slider div.inner{align-content:center;align-items:center;display:table-cell;text-align:center}"]
                },] }
    ];
    NgxMatRangeSliderComponent.propDecorators = {
        minValue: [{ type: core.Input }],
        maxValue: [{ type: core.Input }],
        minColor: [{ type: core.Input }],
        maxColor: [{ type: core.Input }],
        showRuler: [{ type: core.Input }],
        formatLabel: [{ type: core.Input }],
        output: [{ type: core.Output }],
        max: [{ type: core.Input }],
        min: [{ type: core.Input }],
        value: [{ type: core.Input }]
    };

    var NgxMatRangeSliderModule = /** @class */ (function () {
        function NgxMatRangeSliderModule() {
        }
        return NgxMatRangeSliderModule;
    }());
    NgxMatRangeSliderModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [NgxMatRangeSliderComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        slider.MatSliderModule,
                        divider.MatDividerModule,
                        list.MatListModule,
                    ],
                    exports: [NgxMatRangeSliderComponent]
                },] }
    ];

    /*
     * Public API Surface of ngx-mat-range-slider
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxMatRangeSliderComponent = NgxMatRangeSliderComponent;
    exports.NgxMatRangeSliderModule = NgxMatRangeSliderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-mat-range-slider.umd.js.map
