import { EventEmitter, OnInit } from '@angular/core';
import { MatSliderChange } from '@angular/material/slider';
import { ThemePalette } from '@angular/material/core';
export interface RangeType {
    min: number;
    max: number;
}
export declare class NgxMatRangeSliderComponent implements OnInit {
    isMinValueInit: boolean;
    isMaxValueInit: boolean;
    thumbLabel: boolean;
    minValue: number;
    maxValue: number;
    minColor: ThemePalette;
    maxColor: ThemePalette;
    showRuler: boolean;
    formatLabel: (v: any) => any;
    output: EventEmitter<RangeType>;
    maxConf: number;
    set max(m: number);
    get max(): number;
    minConf: number;
    set min(m: number);
    get min(): number;
    set value(v: {
        min: number;
        max: number;
    });
    get rulerArray(): number[];
    ngOnInit(): void;
    valueChange(): void;
    minValueInput(a: MatSliderChange): void;
    maxValueInput(a: MatSliderChange): void;
}
